package com.zskk.dicom.monitor.uploader;

import com.zskk.dicom.monitor.config.Configs;
import com.zskk.dicom.monitor.report.ErrReporter;
import com.zskk.dicom.monitor.utils.ExceptionUtil;

import java.io.File;
import java.util.concurrent.TimeUnit;

public class CurrentUploadRunner implements  Runnable{
    public CurrentUploadRunner() {
    }

    @Override
    public void run() {
        while(true) {
            boolean flag = upload();
            Configs.sysLog.info("--CurrentFileQueue-- System upload flag:" + flag + "\nUploadsQueue.currentFileQueue.size：" + UploadsQueue.currentFileQueue.size());
            try {
                if(flag) {
                    TimeUnit.MILLISECONDS.sleep(10);
                } else {
                    TimeUnit.SECONDS.sleep(1);
                }
            } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }


    public synchronized static boolean upload() {
        boolean flag = false;
        try {
            // 从队列中移除已完成任务
            if(UploadsQueue.currentFileQueue.size() > 0) {
                System.out.println("新文件"+UploadsQueue.currentFileQueue.size()+"-----------------------");
                File file = UploadsQueue.currentFileQueue.remove(0);
                FileUploader.upload(file);
                flag = true;
            }
        } catch (Throwable e) {
            ErrReporter.report(ExceptionUtil.getExceptionTxt(e));
            e.printStackTrace();
        }
        return flag;
    }
}
