package com.zskk.dicom.monitor.uploader;

import com.zskk.dicom.monitor.config.Configs;
import com.zskk.dicom.monitor.report.ErrReporter;
import com.zskk.dicom.monitor.utils.ExceptionUtil;
import com.zskk.dicom.monitor.utils.MonitorFileUtils;

import java.io.File;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
/**
 *
 * 功能描述: 备份移除源文件
 *
 * @param:
 * @return: 
 * @auther: zzp
 * @date: 2019/3/18 15:36
 */
public class SuccessUploadQuenu implements  Runnable {
    private static ExecutorService pools = Executors.newFixedThreadPool(2);
    @Override
    public void run() {
        while(true) {
            boolean flag = mover();
            Configs.sysLog.info("--SuccessFileQueue-- System upload flag:" + flag + "\nUploadsQueue.SuccessFileQueue.size：" + FileUploader.successFileQueue.size());
            try {
                if(flag) {
                    TimeUnit.MILLISECONDS.sleep(10);
                } else {
                    TimeUnit.SECONDS.sleep(1);
                }
            } catch (InterruptedException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }

    }

    public synchronized static boolean mover() {
        boolean flag = false;
        try {
            // 从队列中移除已完成任务
            if(FileUploader.successFileQueue.size() > 0) {
                System.out.println("成功文件队列"+FileUploader.successFileQueue.size()+"个-----------------------");
                File file = FileUploader.successFileQueue.remove(0);
                //备份
                String targetFileStr = MonitorFileUtils.touchBackDir(file);
                //移除源文件
                pools.execute(new FileMover(file, new File(targetFileStr)));
                flag = true;
            }
        } catch (Throwable e) {
            ErrReporter.report(ExceptionUtil.getExceptionTxt(e));
            e.printStackTrace();
        }
        return flag;
    }
}
